using System.Diagnostics;
using System.Data;
using System.Collections;
using Microsoft.VisualBasic;
using System.Collections.Generic;
using System;

namespace Optim_DirectSearch1
{
	public delegate double MyFxDelegate(int nNumVars, ref double[] fX, ref double[] fParam);
	public delegate string SayFxDelegate();
	
	public class CDirectSearch
	{
		
		
		public double DirectSearch(int nNumVars, ref double[] fX, ref double[] fParam, ref double[] fStepSize, ref double[] fMinStepSize, ref int nIter, MyFxDelegate MyFx)
		{
			const int StepReduceFactor = 10;
			
			double fBestF, F, fXX;
			int i;
			bool bStop, bFound;
			
            fBestF = MyFx(nNumVars, ref fX, ref fParam);
			
			nIter = 0;
			do
			{
				nIter++;
				
				for (i = 0; i < nNumVars; i++)
				{
					bFound = false;
					do
					{
						fXX = fX[i];
						fX[i] = fXX + fStepSize[i];
                        F = MyFx(nNumVars, ref fX, ref fParam);
						if (F < fBestF)
						{
							fBestF = F;
							bFound = true;
						}
						else
						{
							fX[i] = fXX - fStepSize[i];
                            F = MyFx(nNumVars, ref fX, ref fParam);
							if (F < fBestF)
							{
								fBestF = F;
								bFound = true;
							}
							else
							{
								fX[i] = fXX;
								if (! bFound)
								{
									fStepSize[i] = fStepSize[i] / StepReduceFactor;
								}
								break;
							}
						}
					} while (true);
				}
				
				bStop = true;
				for (i = 0; i < nNumVars; i++)
				{
					if (fStepSize[i] >= fMinStepSize[i])
					{
						bStop = false;
						break;
					}
				}
				
			} while (!bStop);
			
			return fBestF;
			
		}
	}
	
	
}
