using System.Diagnostics;
using System.Data;
using System.Collections;
using Microsoft.VisualBasic;
using System.Collections.Generic;
using System;

namespace Optim_DirectSearch1
{
	sealed class Module1
	{
		
		static public void Main()
		{
			int nNumVars = 2;
			double[] fX = new double[] { 0, 0 };
			double[] fParam = new double[] { 0, 0 };
			double[] fStepSize = new double[] { 0.1, 0.1 };
			double[] fMinStepSize = new double[] { 0.00001, 0.00001 };
			int nIter = 0;
			int i;
			double fBestF;
			string sAnswer;
			CDirectSearch oOpt;
			MyFxDelegate MyFx = new MyFxDelegate( Fx1);
			SayFxDelegate SayFx = new SayFxDelegate( SayFx1);
			
			oOpt = new CDirectSearch();
			
			Console.WriteLine("Direct Search Optimization");
			Console.WriteLine("Finding the minimu of function:");
			Console.WriteLine(SayFx());
			Console.Write("Use default input values? (Y/N) ");
			sAnswer = Console.ReadLine();
			if (sAnswer.ToUpper() == "Y")
			{
				for (i = 0; i < nNumVars; i++)
				{
					Console.WriteLine("X({0}) = {1}", i + 1, fX[i]);
					Console.WriteLine("Step Size({0}) = {1}", i + 1, fStepSize[i]);
					Console.WriteLine("Min Step Size({0}) = {1}", i + 1, fMinStepSize[i]);
				}
			}
			else
			{
				for (i = 0; i < nNumVars; i++)
				{
					fX[i] = GetIndexedDblInput("X", i + 1, fX[i]);
					fStepSize[i] = GetIndexedDblInput("Initial step size(", i + 1, fStepSize[i]);
					fMinStepSize[i] = GetIndexedDblInput("Minimum step size", i + 1, fMinStepSize[i]);
				}
			}
			
			Console.WriteLine("******** FINAL RESULTS *************");
			fBestF = oOpt.DirectSearch(nNumVars, ref fX, ref fParam, ref fStepSize, ref fMinStepSize, ref nIter, MyFx);
			Console.WriteLine("Optimum at");
			for (i = 0; i < nNumVars; i++)
			{
				Console.WriteLine("X({0}) = {1}", i + 1, fX[i]);
			}
			Console.WriteLine("Function value = {0}", fBestF);
			Console.WriteLine("Number of iterations = {0}", nIter);
			Console.WriteLine();
			Console.Write("Press Enter to end the program ...");
			Console.ReadLine();
		}
		
		static public double GetDblInput(string sPrompt, double fDefInput)
		{
			string sInput;
			
			Console.Write("{0}? ({1}): ", sPrompt, fDefInput);
			sInput = Console.ReadLine();
			if (sInput.Trim(null).Length > 0)
			{
				return double.Parse(sInput);
			}
			else
			{
				return fDefInput;
			}
		}
		
		static public double GetIndexedDblInput(string sPrompt, int nIndex, double fDefInput)
		{
			string sInput;
			
			Console.Write("{0}({1})? ({2}): ", sPrompt, nIndex, fDefInput);
			sInput = Console.ReadLine();
			if (sInput.Trim(null).Length > 0)
			{
				return double.Parse(sInput);
			}
			else
			{
				return fDefInput;
			}
		}

        static public string SayFx1()
        {
            return "F(X) = 10 + (X(1) - 2) ^ 2 + (X(2) + 5) ^ 2";
        }

        static public double Fx1(int N, ref double[] X, ref double[] fParam)
        {
            return 10 + Math.Pow(X[0] - 2, 2) + Math.Pow(X[1] + 5, 2);
        }

        static public string SayFx2()
        {
            return "F(X) = 100 * (X(1) - X(2) ^ 2) ^ 2 + (X(2) - 1) ^ 2";
        }

        static public double Fx2(int N, ref double[] X, ref double[] fParam)
        {
            return Math.Pow(100 * (X[0] - X[1] * X[1]), 2) + Math.Pow((X[1] - 1), 2);
        }

        static public string SayFx3()
        {
            return "F(X) = X(1) - X(2) + 2 * X(1) ^ 2 + 2 * X(1) * X(2) + X(2) ^ 2";
        }

        static public double Fx3(int N, ref double[] X, ref double[] fParam)
        {
            return X[0] - X[1] + 2 * X[0] * X[0] + 2 * X[0] * X[1] + X[1] * X[1];
        }

		
		static public string SayFxFit()
		{
			return "Fitting Yd = 11 - 10 * Exp(-0.75 * Xd) + 8 * Exp(-0.35 * Xd)";
		}
		
		static public double FxFit(int N, ref double[] X, ref double[] fParam)
		{
			const int M = 100;
			
			int i;
			double Xd;
			double Yd;
			double Yd2;
			double SumSqr;
			
			SumSqr = 0;
			for (i = 0; i <= M - 1; i++)
			{
				Xd = 0.1 *(i + 1);
				Yd = 11 - 10 * Math.Exp(- 0.75 * Xd) + 8 * Math.Exp(- 0.35 * Xd);
				Yd2 = X[0] - X[1] * Math.Exp(- X[2] * Xd) + X[3] * Math.Exp(- X[4] * Xd);
				SumSqr = Math.Pow(SumSqr +(Yd - Yd2), 2);
			}
			return SumSqr;
		}
	}
	
}
